/*
 * SdCard.h
 *
 *  Created on: 14.09.2009
 *      Author: mz
 */

#ifndef SDCARD_H_
#define SDCARD_H_

#include "Types.h"
#include "fat.h"
#include "file.h"
#include "mmc.h"

namespace SdCard {

static inline u08 	initCard(void) {
	return mmc_init();
}

static inline u08 	cardIsPresent(void) {
	return mmc_present();
}
static inline u08 	cardIsProtected(void) {
	return mmc_protected();
}

u08 	loadFatData(void) {
	return fat_loadFatData();
}

static inline u08*	toFatName(u08 *str) {
	return fat_str(str);
}

static inline u08 	openFile(u08 name[]) {
	return ffopen(name);
}

static inline u08 	closeFile(void) {
	return ffclose();
}

static inline void 	seekFile(u32 offset) {
	ffseek(offset);
}

static inline u08 	readFile(void) {
	return ffread();
}

static inline void 	writeChar(u08 c) {
	ffwrite(c);
}

static inline void 	writeStrg(u08 *s) {
	ffwrites(s);
}

static inline u08 fileExists( u08 name[]){
  return fat_loadFileDataFromDir(name);
}

static inline u08 	rmFile(u08 name[]) {
	return rmFile(name);
}

static inline u08 	cd(u08 name[]) {
	return cd(name);
}

static inline u08 	cdParent(void) {
	return cdParent();
}

static inline void 	ls(void	) {
	ffls();
}

static inline void 	mkdir(u08 name[]) {
	ffmkdir(name);
}


 } // end of namespace



#endif /* SDCARD_H_ */
